function varargout = batch(varargin)
% BATCH M-file for batch.fig
%      BATCH, by itself, creates a new BATCH or raises the existing
%      singleton*.
%
%      H = BATCH returns the handle to a new BATCH or the handle to
%      the existing singleton*.
%
%      BATCH('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BATCH.M with the given input arguments.
%
%      BATCH('Property','Value',...) creates a new BATCH or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before batch_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to batch_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help batch

% Last Modified by GUIDE v2.5 24-Jun-2010 17:28:16

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @batch_OpeningFcn, ...
                   'gui_OutputFcn',  @batch_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before batch is made visible.
function batch_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to batch (see VARARGIN)

% Choose default command line output for batch
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global checkboxActive;
checkboxActive = 0;
global numFiles;
numFiles=0;
global opts;

opts.segment=0;
opts.denoising=0;
opts.correction=0;
opts.extraction=0;
opts.clasify=0;
opts.remove=0;
opts.reorient=1;
opts.orientation='axial';

% UIWAIT makes batch wait for user response (see UIRESUME)
% uiwait(handles.Batch);


% --- Outputs from this function are returned to the command line.
function varargout = batch_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function file_batch_menu_Callback(hObject, eventdata, handles)
% hObject    handle to file_batch_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function select_files_batch_menu_Callback(hObject, eventdata, handles)
% hObject    handle to select_files_batch_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global numFiles;
global files;

[fileName pathBatch]=uigetfile({'*.img; *.nii'}, 'Choose your acquisition file(s)', 'MultiSelect', 'on');

tam=size(fileName);
if(tam(1,2) >1)

    if ( ischar(fileName(1,1)) )
            numFiles=1;
            set(handles.text_files_loaded, 'String', [num2str(numFiles), ' file loaded']);
            files=[pathBatch,char(fileName)];
    else
            selected=size(fileName);
            numFiles=selected(1,2);
            set(handles.text_files_loaded, 'String', [num2str(numFiles), ' files loaded']);

            for i=1:numFiles        
              filestemp(i,:)=([pathBatch,char(fileName(i))]);
            end    
            files=filestemp;
    end   

end


% --------------------------------------------------------------------
function select_directory_batch_menu_Callback(hObject, eventdata, handles)
% hObject    handle to select_directory_batch_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global files;
global numFiles;
global opts;

directoryPath = uigetdir('Choose your acquisitions folder');

% If we've selected one directory..
if (directoryPath ~=0)

    lista1=ls([directoryPath, '/*.nii']);
    lista2=ls([directoryPath, '/*.img']);

    s1=size(lista1);
    s2=size(lista2);

    files=char(zeros((s1(1)+s2(1)),max(s1(2),s2(2))));
    s=size(files);

    for i=1:s1(1)
      files(i,1:length(lista1(i,:)))=lista1(i,:);
    end
    for i=(s1(1)+1):s(1)
      files(i,1:length(lista2(i-s1(1),:)))=lista2(i-s1(1),:);
    end

    tam=size(files);
    numFiles=tam(1,1);

    if (numFiles == 1)
        set(handles.text_files_loaded, 'String', [num2str(numFiles), ' file loaded']);
    elseif (numFiles > 1)
        set(handles.text_files_loaded, 'String', [num2str(numFiles), ' files loaded']);
    end
    
    for i=1:numFiles
        filestemp(i,:)=[directoryPath,'\',files(i,:)];
    end
    files=filestemp;        

end


% --------------------------------------------------------------------
function exit_batch_menu_Callback(hObject, eventdata, handles)
% hObject    handle to exit_batch_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% global fileName;
% global pathBatch;

global files;
global numFiles;
clearvar files;
clearvar numFiles;
close;

%brainseg;


% --- Executes on button press in radio_axial.
function radio_axial_Callback(hObject, eventdata, handles)
% hObject    handle to radio_axial (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_axial


% --- Executes on button press in radio_coronal.
function radio_coronal_Callback(hObject, eventdata, handles)
% hObject    handle to radio_coronal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_coronal


% --- Executes on button press in radio_sagittal.
function radio_sagittal_Callback(hObject, eventdata, handles)
% hObject    handle to radio_sagittal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_sagittal



function editPath_Callback(hObject, eventdata, handles)
% hObject    handle to editPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editPath as text
%        str2double(get(hObject,'String')) returns contents of editPath as a double


% --- Executes during object creation, after setting all properties.
function editPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_set_path.
function button_set_path_Callback(hObject, eventdata, handles)
% hObject    handle to button_set_path (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global savePath;

savePath = uigetdir('Choose your acquisitions folder');

if (savePath ~= 0)
    set(handles.editPath, 'String', savePath);
end


% --- Executes on button press in pushbutton_run.
function pushbutton_run_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global checkboxActive;
global numFiles;
% global fileName;
% global pathBatch;
% global directoryPath;
global files;
global opts;

global pathSave;

if( (isempty(get(handles.editPath, 'String'))) && (isempty(get(handles.editBrainseg, 'String'))) )
    errordlg('You must specify the destination path before run batch process.', 'No Path Specified');
elseif (checkboxActive == 0)
    errordlg('You must choose at least one process to run.', 'No Processes Chosen');
elseif (numFiles == 0)
    errordlg('Load any file before run.', 'No File(s) Loaded');

    
else
    
    warning('OFF', 'MATLAB:MKDIR:DirectoryExists'); % Disable warning
    
    disp('Creating directories and storing data in axial orientation...');

        if (~isempty(get(handles.editPath, 'String'))) % If user entered a complete path
            pathSave=get(handles.editPath, 'String'); 
        else
            userSelect=get(handles.editBrainseg, 'String'); %If user typed a personal dir under brainseg\results\
            mkdir(['results\', userSelect]);
            pathSave=[pwd, '\results\', userSelect];
        end
                
        opts.nfiles=numFiles;
        opts.save=pathSave;
        
        if (get(handles.radio_axial, 'Value') == 1)
            opts.orientation='axial';
        end
        if (get(handles.radio_coronal, 'Value') == 1)
            opts.orientation='coronal';
        end
        if (get(handles.radio_sagittal, 'Value') == 1)
            opts.orientation='sagittal';
        end
       
        if (get(handles.checkbox_segment, 'Value') == 1)
            opts.segment=1;
        end
        
        if (get(handles.checkbox_remove_intermedied, 'Value') == 1)
            opts.remove=1;
        end
        
        if (get(handles.checkbox_denoising, 'Value') == 1)
            opts.denoising=1;
        end
        
        if (get(handles.checkbox_correction, 'Value') == 1)
            opts.correction=1;
        end
        
        if (get(handles.checkbox_extraction, 'Value') == 1)
            opts.extraction=1;
        end
        
        if (get(handles.checkbox_classification, 'Value') == 1)
            opts.clasify=1;
        end
              
                                    
        run_batch(files,opts);                    

        close;
end




% --- Executes on button press in checkbox_denoising.
function checkbox_denoising_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_denoising (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_denoising
global checkboxActive;

if (get(hObject, 'Value') == 1)
    checkboxActive=1;
else
    checkboxActive=0;
end


% --- Executes on button press in checkbox_correction.
function checkbox_correction_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_correction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_correction
global checkboxActive;

if (get(hObject, 'Value') == 1)
    checkboxActive=1;
else
    checkboxActive=0;
end


% --- Executes on button press in checkbox_extraction.
function checkbox_extraction_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_extraction (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_extraction
global checkboxActive;

if (get(hObject, 'Value') == 1)
    checkboxActive=1;
else
    checkboxActive=0;
end


% --- Executes on button press in checkbox_segment.
function checkbox_segment_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_segment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global checkboxActive;

if (get(hObject, 'Value') == 1)
    set(handles.checkbox_denoising, 'Value', 1);
    set(handles.checkbox_correction, 'Value', 1);    
    set(handles.checkbox_extraction, 'Value', 1);    
    set(handles.checkbox_classification, 'Value', 1);
    checkboxActive=1;
else
    set(handles.checkbox_denoising, 'Value', 0);
    set(handles.checkbox_correction, 'Value', 0);    
    set(handles.checkbox_extraction, 'Value', 0);    
    set(handles.checkbox_classification, 'Value', 0);
    checkboxActive=0;
end
% Hint: get(hObject,'Value') returns toggle state of checkbox_segment


% --- Executes on button press in checkbox_classification.
function checkbox_classification_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_classification (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_classification
global checkboxActive;

if (get(hObject, 'Value') == 1)
    checkboxActive=1;
else
    checkboxActive=0;
end


% --- Executes when selected object is changed in panel_orientation.
function panel_orientation_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in panel_orientation 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

if (hObject == handles.radio_axial)
    opts.orientation='axial';
end
if (hObject == handles.radio_coronal)
    opts.orientation='coronal';
end
if (hObject == handles.radio_sagittal)
    opts.orientation='sagittal';
end


% --- Executes during object creation, after setting all properties.
function panel_orientation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to panel_orientation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

opts.orientation='axial';


% --- Executes on button press in checkbox_remove_intermedied.
function checkbox_remove_intermedied_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_remove_intermedied (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_remove_intermedied



function editBrainseg_Callback(hObject, eventdata, handles)
% hObject    handle to editBrainseg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editBrainseg as text
%        str2double(get(hObject,'String')) returns contents of editBrainseg as a double


% --- Executes during object creation, after setting all properties.
function editBrainseg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBrainseg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on editBrainseg and none of its controls.
function editBrainseg_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to editBrainseg (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)




