function varargout = gui(varargin)
% GUI M-file for gui.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui

% Last Modified by GUIDE v2.5 21-Aug-2010 12:37:58

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gui is made visible.
function gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui (see VARARGIN)

% Choose default command line output for gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes gui wait for user response (see UIRESUME)
% uiwait(handles.guiWindow);

global vol;
global V;
global arg;
global res;
global f;
global origin;
global volImg;
global volOriginal;
global cutAxial;
global cutSagittal;
global cutCoronal;
global left;
global rect;
global brillo;
global sizeVolImg;
global maxSize;
global overlay;
global map;
global enable;
global resultspath;
global fname;
global limit_a;
global limit_s;
global limit_c;
global mapa;
global right;
global pencil;

% Initialize tools section

set(handles.disable_editor_menu, 'Enable', 'off'); % Both menus are disabled by default
set(handles.save_mask_menu, 'Enable', 'off');
% End of init.

enable=0; 
right=0;
left=0;
brillo=0;
overlay=0;
pencil=0;

if(isempty(arg.img_name))
  volOriginal=zeros(64,64,64);
  res=[1,1,1];
  arg.axial = 1;
  
  %Disable tool menus if acquisition is not loaded
  set(handles.denoising_menu, 'Enable', 'off');
  set(handles.correction_menu, 'Enable', 'off');
  set(handles.extraction_menu, 'Enable', 'off');
  set(handles.classification_menu, 'Enable', 'off');
  set(handles.segment_menu, 'Enable', 'off');
  set(handles.save_options_menu, 'Enable', 'off');
  set(handles.buttonZoom, 'Enable', 'off');  
  set(handles.buttonPan, 'Enable', 'off');
  set(handles.buttonPencil, 'Enable', 'off');
  set(handles.popupmenu_size, 'Enable', 'off');
  set(handles.popupmenu_label, 'Enable', 'off');
  
  %Disable overlay options
  set(handles.load_overlay_menu, 'Enable', 'off');
  set(handles.unload_overlay_menu, 'Enable', 'off');
  set(handles.transparency_menu, 'Enable', 'off');
    
else
    
  V = spm_vol(arg.img_name);
  volOriginal=spm_read_vols(V);
  
  res(1)=abs(V.mat(1,1));
  res(2)=abs(V.mat(2,2));
  res(3)=abs(V.mat(3,3));
  
  origin(1)=V.mat(1,4);
  origin(2)=V.mat(2,4);
  origin(3)=V.mat(3,4);
    
  set(handles.denoising_menu, 'Enable', 'on');
  set(handles.correction_menu, 'Enable', 'on');
  set(handles.extraction_menu, 'Enable', 'on');
  set(handles.classification_menu, 'Enable', 'on');
  set(handles.segment_menu, 'Enable', 'on');
  set(handles.save_options_menu, 'Enable', 'on');
  set(handles.buttonZoom, 'Enable', 'on');
  set(handles.buttonPan, 'Enable', 'on');
  
  %Enable overlay options
  set(handles.load_overlay_menu, 'Enable', 'on');
  set(handles.unload_overlay_menu, 'Enable', 'on');
  set(handles.transparency_menu, 'Enable', 'on');
  
  %Set saving as axial by default
  set(handles.save_axial_menu, 'Checked', 'on');
  
  % Set information data in information box
  
  [infopath,infoname,infoext]=fileparts(arg.img_name);
  
  infoFilename=[infoname,infoext];
  
  set(handles.text_info, 'String', { ['Filename: ', infoFilename ] });
  set(handles.text_info, 'String', [get(handles.text_info, 'String'), {['Volume Size: ', num2str(size(volOriginal)) ]} ]);                 
  
end

stemp=size(volOriginal);

% If the acquisition is axial
if (arg.axial == 1)
    colormap(gray);
    
    arg.s=size(volOriginal);
    
    % If all voxels are the same size, then call resizeVol function
    if (res(1) == res(2) && res(3)==res(1))
        volImg=resizeVol(volOriginal);     
    else
        resMin=min(res); % Store the minimum value of res
        f=res/resMin; % Calculate new resolution value and call to the interpolation function
        volTemp=volReformat(volOriginal, f);     
              
        volImg=resizeVol(volTemp);
    end

   
    % createcolormap
    Imin=round(min(volImg(:)));
    volImg=volImg-Imin;
    Imax=round(max(volImg(:)));
    volImg=volImg*255/Imax;
    Imax=255;    
    mapa=zeros(Imax,3);
    
    % If adquisition is axial copy Original volume in new vol
    vol=volOriginal;
    
    for i=1:Imax
      mapa(i,1)=(i-1)/(Imax-1);
      mapa(i,2)=(i-1)/(Imax-1);
      mapa(i,3)=(i-1)/(Imax-1);
    end
    colormap(mapa);
    
    sizeVolImg=size(volImg);
    
% For each image we'll show the central cut without labels
    axes(handles.axesAxial);
    cutAxial=round((sizeVolImg(3)/2));
    image(imrotate(volImg(:,:,cutAxial),90));
    set(handles.axesAxial, 'Tag', 'axial');
    axis off;
    
    axes(handles.axesSagital);
    cutSagittal=round((sizeVolImg(1)/2));
    sag(:,:)=volImg(cutSagittal,:,:);
    image(imrotate(sag,90));
    set(handles.axesSagital, 'Tag', 'sagittal');
    axis off;
    
    axes(handles.axesCoronal);
    cutCoronal=round((sizeVolImg(2)/2));
    cor(:,:)=volImg(:,cutCoronal,:);
    image(imrotate(cor,90));
    set(handles.axesCoronal, 'Tag', 'coronal');
    axis off;
    
end


% If the acquisition is coronal
if (arg.coronal == 1)
    colormap(gray);

    %Create new matrix to store fixed acquisition in axial orientation
     vol=zeros(stemp(1),stemp(3),stemp(2));
     
     % Copy axials images in the new matrix
     for i=1:stemp(2)
          vol(:,:,i)=imrotate(squeeze(volOriginal(:,i,:)),180);
     end
     
     
      tt=res(2);
      res(2)=res(3);
      res(3)=tt;

      tt=origin(2);
      origin(2)=origin(3);
      origin(3)=tt;
          
      arg.s=size(vol);
     
     % If all voxels are the same size, then call volImg function
    if (res(1) == res(2) && res(3)==res(1))
        volImg=resizeVol(vol);
    else
        resMin=min(res);
        f=res/resMin;
        volTemp=volReformat(vol, f);
        volImg=resizeVol(volTemp);
    end

    % createcolormap
    Imin=round(min(volImg(:)));
    volImg=volImg-Imin+1;
    Imax=round(max(volImg(:)));
    volImg=volImg*255/Imax;
    Imax=255;    
    
    
    mapa=zeros(Imax,3);
    
    for i=1:Imax
      mapa(i,1)=(i-1)/(Imax-1);
      mapa(i,2)=(i-1)/(Imax-1);
      mapa(i,3)=(i-1)/(Imax-1);
    end
    colormap(mapa);
    
  
     sizeVolImg=size(volImg);
     
     axes(handles.axesAxial);
     cutAxial=round((sizeVolImg(3)/2));
     image(imrotate(volImg(:,:,cutAxial),90));
     set(handles.axesAxial, 'Tag', 'axial');
     axis off;
     
     axes(handles.axesSagital);
     cutSagittal=round((sizeVolImg(1)/2));
     sag(:,:)=volImg(cutSagittal,:,:);
     image(imrotate(sag,90));
     set(handles.axesSagital, 'Tag', 'sagittal');
     axis off;
    
     axes(handles.axesCoronal);
     cutCoronal=round((sizeVolImg(2)/2));
     cor(:,:)=volImg(:,cutCoronal,:);
     image(imrotate(cor,90));
     set(handles.axesCoronal, 'Tag', 'coronal');
     axis off;


end


% If acquisition is sagittal
if (arg.sagittal == 1)
    colormap(gray);
    
    %Create new matrix to store fixed acquisition in axial orientation
    vol=zeros(stemp(3),stemp(1),stemp(2));    

     % Copy axials images in the new matrix
     for i=1:stemp(2)
          vol(:,:,i)=imrotate(squeeze(volOriginal(:,i,:)), 90);
     end
               
    tt1=res(1);
    tt2=res(2);    
    res(1)=res(3);
    res(2)=tt1;
    res(3)=tt2;
    
    tt1=origin(1);
    tt2=origin(2);
    origin(1)=origin(3);
    origin(2)=tt1;
    origin(3)=tt2;
      
    arg.s=size(vol);
     
    if (res(1) == res(2) && res(3)==res(1))
        volImg=resizeVol(vol);
    else
        resMin=min(res);
        f=res/resMin;
        volTemp=volReformat(vol, f);
        volImg=resizeVol(volTemp);
    end
    
    % createcolormap
    Imin=round(min(volImg(:)));
    volImg=volImg-Imin+1;
    Imax=round(max(volImg(:)));
    volImg=volImg*255/Imax;
    Imax=255;    
    
    vol=double(vol);
    
    
    
    mapa=zeros(Imax,3);
    for i=1:Imax
      mapa(i,1)=(i-1)/(Imax-1);
      mapa(i,2)=(i-1)/(Imax-1);
      mapa(i,3)=(i-1)/(Imax-1);
    end    
    colormap(mapa);
    
    
    sizeVolImg=size(volImg);
    
    
     axes(handles.axesAxial);
     cutAxial=round((sizeVolImg(3)/2));
     image(imrotate(volImg(:,:,cutAxial),90));
     set(handles.axesAxial, 'Tag', 'axial');
     axis off;
     
     axes(handles.axesSagital);
     cutSagittal=round((sizeVolImg(1)/2));
     sag(:,:)=volImg(cutSagittal,:,:);
     image(imrotate(sag,90));
     set(handles.axesSagital, 'Tag', 'sagittal');
     axis off;
    
     axes(handles.axesCoronal);
     cutCoronal=round((sizeVolImg(2)/2));
     cor(:,:)=volImg(:,cutCoronal,:);
     image(imrotate(cor,90));
     set(handles.axesCoronal, 'Tag', 'coronal');
     axis off;

   

end


% --- Outputs from this function are returned to the command line.
function varargout = gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% Update views of volume, depending where x and y has been pressed
function position_update(handles, x, y, axedSelected)

global cutAxial;
global cutCoronal;
global cutSagittal;
global overlay;
global sizeVolImg;
global volImgFusion;
global volImg;

if ( ((x>0) && (x<sizeVolImg(1))) && ((y>0) && (y<sizeVolImg(1))) )
                    
    % For each cut, if we are working with loaded overlay, we'll show the
    % fusion image instead of normal volume.
    switch axedSelected
        case 'axial'         
            
            axes(handles.axesCoronal);
            cutCoronal=(round((sizeVolImg(2)-y)));
            if (overlay == 1)
              cor(:,:)=volImgFusion(:,cutCoronal,:);
            else
              cor(:,:)=volImg(:,cutCoronal,:);
            end
            image(imrotate(cor,90));
            set(handles.axesCoronal, 'Tag', 'coronal');
            axis off;
            
            axes(handles.axesSagital);
            cutSagittal=round(((x)));
            if (overlay == 1)
              sag(:,:)=volImgFusion(cutSagittal,:,:);
            else
              sag(:,:)=volImg(cutSagittal,:,:);
            end
            image(imrotate(sag,90));
            set(handles.axesSagital, 'Tag', 'sagittal');
            axis off;
            
            

        case 'coronal'

             axes(handles.axesAxial);
             cutAxial=(sizeVolImg(2)-y);
             if (overlay == 1)
               ax(:,:)=volImgFusion(:,:,cutAxial);
             else
               ax(:,:)=volImg(:,:,cutAxial);
             end             
             image(imrotate(ax,90));
             set(handles.axesAxial, 'Tag', 'axial');
             axis off;
             
             axes(handles.axesSagital);
             cutSagittal=round(((x)));
             if (overlay == 1)
               sag(:,:)=volImgFusion(cutSagittal,:,:);
             else
               sag(:,:)=volImg(cutSagittal,:,:);
             end
             image(imrotate(sag,90));
             set(handles.axesSagital, 'Tag', 'sagittal');
             axis off;

        case 'sagittal'

            axes(handles.axesAxial);
            cutAxial=(sizeVolImg(2)-y);
            if (overlay == 1)
                ax(:,:)=volImgFusion(:,:,cutAxial);
            else
                ax(:,:)=volImg(:,:,cutAxial);
            end
            image(imrotate(ax,90));
            set(handles.axesAxial, 'Tag', 'axial');
            axis off;

            axes(handles.axesCoronal);
            cutCoronal=(round((x)));
            if (overlay == 1)
              cor(:,:)=volImgFusion(:,cutCoronal,:);
            else
              cor(:,:)=volImg(:,cutCoronal,:);
            end
            image(imrotate(cor,90));
            set(handles.axesCoronal, 'Tag', 'coronal');
            axis off;

    end
    
    

end


         


function [vol]=volReformatOverlay(data,f)


s=round(f.*size(data));

vol=zeros(s);

sOver=size(data);

temp = zeros([s(1),s(2),sOver(3)]);

  for i=1:sOver(3)
    temp(:,:,i)=imresize(data(:,:,i),s(1:2),'bilinear');
  end
  
   for i=1:sOver(1)       
    vol(i,:,:)=imresize(squeeze(temp(i,:,:)),s(2:3),'bilinear');
   end
   
    
% --- Executes on scroll wheel click while the figure is in focus.
function guiWindow_WindowScrollWheelFcn(hObject, eventdata, handles)
% hObject    handle to guiWindow (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	VerticalScrollCount: signed integer indicating direction and number of clicks
%	VerticalScrollAmount: number of lines scrolled for each click
% handles    structure with handles and user data (see GUIDATA)

global volImg;
global volImgFusion;
global cutAxial;
global cutCoronal;
global cutSagittal;
global arg;
global overlay;
global sizeVolImg;

axedSelected=get(gca, 'Tag');

if (length(arg.img_name) ~=0)
    switch axedSelected

        case 'axial'
            axes(handles.axesAxial);
            cutAxial=cutAxial + eventdata.VerticalScrollCount;

            if ((cutAxial >= 1) && (cutAxial < sizeVolImg(3)))
                if (overlay == 1)
                    image(imrotate(volImgFusion(:,:,cutAxial),90));
                else
                    image(imrotate(volImg(:,:,cutAxial),90));
                end
            else
                cutAxial = cutAxial - eventdata.VerticalScrollCount;
            end

            set(handles.textCoordZ, 'String', cutAxial-1);            

            set(handles.axesAxial, 'Tag', 'axial');
            axis off;
        case 'coronal'
            axes(handles.axesCoronal);
            cutCoronal=cutCoronal + eventdata.VerticalScrollCount;

            if ((cutCoronal >= 1) && (cutCoronal < sizeVolImg(3)))
                if (overlay == 1)
                    cor(:,:)=volImgFusion(:,cutCoronal,:);
                else
                    cor(:,:)=volImg(:,cutCoronal,:);
                end
              image(imrotate(cor,90));
            else
                cutCoronal = cutCoronal - eventdata.VerticalScrollCount;
            end

            set(handles.textCoordY, 'String', cutCoronal-1);            

            set(handles.axesCoronal, 'Tag', 'coronal');
            axis off;

        case 'sagittal'

            axes(handles.axesSagital);

            cutSagittal= cutSagittal + eventdata.VerticalScrollCount;

            if ((cutSagittal >= 1) && (cutSagittal < sizeVolImg(3)))
                if (overlay == 1)
                    sag(:,:)=volImgFusion(cutSagittal,:,:);
                else
                    sag(:,:)=volImg(cutSagittal,:,:);
                end
                image(imrotate(sag,90));
            else
                cutSagittal = cutSagittal - eventdata.VerticalScrollCount;
            end

            set(handles.textCoordX, 'String', cutSagittal-1);

            set(handles.axesSagital, 'Tag', 'sagittal');
            axis off;
    end
end


% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function guiWindow_WindowButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to guiWindow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 global volImg;
 global volImgFusion;
 global sizeVolImg;
 global left;
 global f;
 global rect;
 global overImg;
 global volImgOverlay;
 global offsetx;
 global offsety;
 global offsetz;
 global cutAxial;
 global cutSagittal;
 global cutCoronal;
 global arg;
 global enable;
 global pencil;
 global right;
 global sizeOverImg;
 
 axedSelected=get(gca, 'Tag');
 pos=get(gca,'CurrentPoint');
 x=round(pos(1,1));
 y=round(pos(1,2));
 
  
if strcmp(get(gcf,'SelectionType'),'normal')
    left=1;
    right=0;
end
if strcmp(get(gcf,'SelectionType'),'alt')    
    left=0;
    right=1;
end

% If editor is enable and we want to draw
if(enable == 1 && pencil==1)
   
  if ( ((x>0) && (x<sizeVolImg(1))) && ((y>0) && (y<sizeVolImg(1))) )
      
      
            switch axedSelected
                case 'axial'         

                    cutCoronal=(round((sizeVolImg(2)-y+1)));            
                    cutSagittal=round(((x)));                     

                case 'coronal'

                     cutAxial=(sizeVolImg(2)-y)+1;
                     cutSagittal=round(((x)));

                case 'sagittal'

                    cutAxial=(sizeVolImg(2)-y+1);
                    cutCoronal=(round((x)));
            end
    
            x1=round((cutSagittal-offsetx)/f(1));
            y1=round((cutCoronal-offsety)/f(2));
            z1=round((cutAxial-offsetz)/f(3)); 
            
                     
            sizeSelected = get(handles.popupmenu_size, 'Value')-1;
            
            
            % Left click
            if(left==1)                                                                        
                
                labelMax=max(overImg(:));
                labelValue=get(handles.popupmenu_label, 'Value');
                
                for i=-sizeSelected:sizeSelected
                    for j=-sizeSelected:sizeSelected
                        for k=-sizeSelected:sizeSelected
                            newX=x1+i;
                            newY=y1+j;
                            newZ=z1+k;
                            
                            d = sqrt(i*i + j*j + k*k);
                            if ( d > sizeSelected)
                                continue;
                            end
                            
                            if( (newX>0 && newX<=sizeOverImg(1)) && (newY>0 && newY<=sizeOverImg(2)) && (newZ>0 && newZ<=sizeOverImg(3)) )
                                
                                overImg(newX, newY, newZ)=labelValue;
                                
                            end
                            
                            newSagittal=cutSagittal+i;
                            newCoronal=cutCoronal+j;
                            newAxial=cutAxial+k;
                            
                            
                            % Quizas haya que meter una guarda aqui para no
                            % salirnos de la imagen
                            
                            if ( ((newSagittal>0) && (newSagittal<sizeVolImg(1))) && ((newCoronal>0) && (newCoronal<sizeVolImg(1))) && ((newAxial>0) && (newAxial<sizeVolImg(1))))
                                volImgOverlay(newSagittal, newCoronal, newAxial)=(255*labelValue)/labelMax;
                                volImgFusion(newSagittal, newCoronal, newAxial)=129 + (volImg(newSagittal, newCoronal, newAxial).*(volImgOverlay(newSagittal, newCoronal, newAxial)))/(256);
                            end
                            
                        end
                    end
                end
                                                                                                                                  
                    
                if (labelValue > labelMax)
                    change_alfa(labelValue);
                end
                
            end % End of if left
            
            
            % Right click
            if(right==1) 
                
                for i=-sizeSelected:sizeSelected
                    for j=-sizeSelected:sizeSelected
                        for k=-sizeSelected:sizeSelected
                            newX=x1+i;
                            newY=y1+j;
                            newZ=z1+k;
                
                            d = sqrt(i*i + j*j + k*k);
                            if ( d > sizeSelected)
                                continue;
                            end
                            
                            if( (newX>0 && newX<=sizeOverImg(1)) && (newY>0 && newY<=sizeOverImg(2)) && (newZ>0 && newZ<=sizeOverImg(3)) )
                                overImg(newX, newY, newZ)=0;
                            end
                            
                            newSagittal=cutSagittal+i;
                            newCoronal=cutCoronal+j;
                            newAxial=cutAxial+k;
                
                            volImgOverlay(newSagittal, newCoronal, newAxial)=0;
                            volImgFusion(newSagittal, newCoronal, newAxial)=0.5*volImg(newSagittal, newCoronal, newAxial); 
                        end
                    end
                end
                
            end % End of if right
                
            axes(handles.axesAxial);
            image(imrotate(volImgFusion(:,:,cutAxial),90));
            set(handles.axesAxial, 'Tag', 'axial');
            axis off;
            zoom(1);

            axes(handles.axesSagital);
            sag(:,:)=volImgFusion(cutSagittal,:,:);
            image(imrotate(sag,90));
            set(handles.axesSagital, 'Tag', 'sagittal');
            axis off;
            zoom(1);

            axes(handles.axesCoronal);
            cor(:,:)=volImgFusion(:,cutCoronal,:);
            image(imrotate(cor,90));
            set(handles.axesCoronal, 'Tag', 'coronal');
            axis off;                        
            zoom(1);     
                       
   end                                        
end
      
% Prueba para click derecho
if pencil==0 && strcmp(get(gcf,'SelectionType'),'alt')     

         if(strcmp(axedSelected,'axial'))
             rect=getrect(handles.axesAxial);
             rect=round(rect);
             reg=volImg(rect(1):(rect(1)+rect(3)),rect(2):(rect(2)+rect(4)),cutAxial);
             m1=min(reg(:));
             m2=max(reg(:));
             CambiarBrillo(m1,m2);
             return;
         end

         if(strcmp(axedSelected,'sagittal'))
            rect=getrect(handles.axesSagital);
            rect=round(rect);
            reg=volImg(rect(1):(rect(1)+rect(3)),rect(2):(rect(2)+rect(4)),cutSagittal);
            m1=min(reg(:));
            m2=max(reg(:));
            CambiarBrillo(m1,m2);
            return;
         end

         if(strcmp(axedSelected,'coronal'))
            rect=getrect(handles.axesCoronal);
            rect=round(rect);
            reg=volImg(rect(1):(rect(1)+rect(3)),rect(2):(rect(2)+rect(4)),cutCoronal);
            m1=min(reg(:));
            m2=max(reg(:));
            CambiarBrillo(m1,m2);
            return;
         end
end

position_update(handles, x, y, axedSelected);

if(length(arg.img_name) ~= 0)
        switch axedSelected
            case 'axial'
                axes(handles.axesAxial);
                set(handles.textCoordZ, 'String', cutAxial-1);
            case 'coronal'
                axes(handles.axesCoronal);
                set(handles.textCoordY, 'String', cutCoronal-1);
            case 'sagittal'
                axes(handles.axesSagital);
                set(handles.textCoordX, 'String', cutSagittal-1);
        end
end


% --------------------------------------------------------------------
function new_acquisition_Callback(hObject, eventdata, handles)
% hObject    handle to new_acquisition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global overlay;

overlay=0;
loadFile;


% --- Executes on mouse motion over figure - except title and menu.
function guiWindow_WindowButtonMotionFcn(hObject, eventdata, handles)
% hObject    handle to guiWindow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 global volImg;
 global volImgFusion;
 global volImgOverlay;
 global overImg;
 global left;
 global right;
 global cutAxial;
 global cutSagittal;
 global cutCoronal;
 global arg;
 global f;
 global offsetx;
 global offsety;
 global offsetz;
 global enable;
 global pencil;
 global sizeVolImg;
 global sizeOverImg;
 
 s=sizeVolImg;
 
 axedSelected=get(gca, 'Tag');
 
 posPointer=get(gca,'CurrentPoint');
 
 if(length(arg.img_name)~=0)
     
     switch axedSelected
        case 'axial'
            xP=round(posPointer(1,1));
            yP=(s(2)-round(posPointer(1,2)));
            if(xP>0 && xP<=s(1) && yP>0 && yP<=s(2))
                set(handles.textCoordX, 'String', xP-1); 
                set(handles.textCoordY, 'String', yP-1);
                set(handles.textCoordZ, 'String', cutAxial-1);            
                set(handles.valor, 'String', volImg(xP,yP,cutAxial));            
            end
        case 'coronal'
            xP=round(posPointer(1,1));
            yP=(s(3)-round(posPointer(1,2)));
            if(xP>0 && xP<=s(1) && yP>0 && yP<=s(3))
                set(handles.textCoordX, 'String', xP-1); 
                set(handles.textCoordZ, 'String', yP-1);
                set(handles.textCoordY, 'String', cutCoronal-1);            
                set(handles.valor, 'String', volImg(xP,cutCoronal,yP));            
            end
        case 'sagittal'
            xP=round(posPointer(1,1));
            yP=(s(3)-round(posPointer(1,2)));
            if(xP>0 && xP<=s(1) && yP>0 && yP<=s(3))
                set(handles.textCoordY, 'String', xP-1); 
                set(handles.textCoordZ, 'String', yP-1);
                set(handles.textCoordX, 'String', cutSagittal-1);            
                set(handles.valor, 'String', volImg(cutSagittal,xP,yP));            
            end
      end

 end
 
     
axedSelected=get(gca, 'Tag');
pos=get(gca,'CurrentPoint');
x=round(pos(1,1));
y=round(pos(1,2));


if ( (left == 1 || right==1) && (enable == 1) && (pencil == 1))
    
    if ( ((x>0) && (x<sizeVolImg(1))) && ((y>0) && (y<sizeVolImg(1))) )
                    
    
            switch axedSelected
                case 'axial'         

                    cutCoronal=(round((sizeVolImg(2)-y+1)));            
                    cutSagittal=round(((x)));                     

                case 'coronal'

                     cutAxial=(sizeVolImg(2)-y+1);
                     cutSagittal=round(((x)));

                case 'sagittal'

                    cutAxial=(sizeVolImg(2)-y+1);
                    cutCoronal=(round((x)));

            end
            
            x1=round((cutSagittal-offsetx)/f(1));
            y1=round((cutCoronal-offsety)/f(2));
            z1=round((cutAxial-offsetz)/f(3));
            
            sizeSelected = get(handles.popupmenu_size, 'Value')-1;
            
            
            if(left==1)
                
                labelMax=max(overImg(:));
                labelValue=get(handles.popupmenu_label, 'Value');
                
                for i=-sizeSelected:sizeSelected
                    for j=-sizeSelected:sizeSelected
                        for k=-sizeSelected:sizeSelected
                            newX=x1+i;
                            newY=y1+j;
                            newZ=z1+k;
                            
                            d = sqrt(i*i + j*j + k*k);
                            if ( d > sizeSelected)
                                continue;
                            end
                            
                            if( (newX>0 && newX<=sizeOverImg(1)) && (newY>0 && newY<=sizeOverImg(2)) && (newZ>0 && newZ<=sizeOverImg(3)) )
                                
                                overImg(newX, newY, newZ)=labelValue;
                                
                            end
                            
                            newSagittal=cutSagittal+i;
                            newCoronal=cutCoronal+j;
                            newAxial=cutAxial+k;
                            
                                                        
                            if ( ((newSagittal>0) && (newSagittal<sizeVolImg(1))) && ((newCoronal>0) && (newCoronal<sizeVolImg(1))) && ((newAxial>0) && (newAxial<sizeVolImg(1))))
                                volImgOverlay(newSagittal, newCoronal, newAxial)=(255*labelValue)/labelMax;
                                volImgFusion(newSagittal, newCoronal, newAxial)=129 + (volImg(newSagittal, newCoronal, newAxial).*(volImgOverlay(newSagittal, newCoronal, newAxial)))/(256);
                            end
                            
                        end
                    end
                end
                
%                 volImgOverlay(cutSagittal, cutCoronal, cutAxial)=255;
%                 volImgFusion(cutSagittal, cutCoronal, cutAxial)=129 + (volImg(cutSagittal, cutCoronal, cutAxial).*(volImgOverlay(cutSagittal, cutCoronal, cutAxial)))/(256);            

                if (labelValue > labelMax)
                    change_alfa(labelValue);
                end
            end
            
            if(right==1) 
                
                for i=-sizeSelected:sizeSelected
                    for j=-sizeSelected:sizeSelected
                        for k=-sizeSelected:sizeSelected
                            newX=x1+i;
                            newY=y1+j;
                            newZ=z1+k;
                
                            d = sqrt(i*i + j*j + k*k);
                            if ( d > sizeSelected)
                                continue;
                            end
                            
                            if( (newX>0 && newX<=sizeOverImg(1)) && (newY>0 && newY<=sizeOverImg(2)) && (newZ>0 && newZ<=sizeOverImg(3)) )
                                overImg(newX, newY, newZ)=0;
                            end
                            
                            newSagittal=cutSagittal+i;
                            newCoronal=cutCoronal+j;
                            newAxial=cutAxial+k;
                
                            volImgOverlay(newSagittal, newCoronal, newAxial)=0;
                            volImgFusion(newSagittal, newCoronal, newAxial)=0.5*volImg(newSagittal, newCoronal, newAxial); 
                        end
                    end
                end
                
%                 volImgOverlay(cutSagittal, cutCoronal, cutAxial)=0; 
%                 volImgFusion(cutSagittal, cutCoronal, cutAxial)=0.5*volImg(cutSagittal, cutCoronal, cutAxial);                        
            end

            axes(handles.axesAxial);
            image(imrotate(volImgFusion(:,:,cutAxial),90));
            set(handles.axesAxial, 'Tag', 'axial');
            axis off;
            zoom(1);

            axes(handles.axesSagital);
            sag(:,:)=volImgFusion(cutSagittal,:,:);
            image(imrotate(sag,90));
            set(handles.axesSagital, 'Tag', 'sagittal');
            axis off;
            zoom(1);

            axes(handles.axesCoronal);
            cor(:,:)=volImgFusion(:,cutCoronal,:);
            image(imrotate(cor,90));
            set(handles.axesCoronal, 'Tag', 'coronal');
            axis off;                        
            zoom(1);                            
            
    end
end

if(left==1 && pencil == 0)
    
    position_update(handles, x, y, axedSelected);

    switch axedSelected
        case 'axial'
            axes(handles.axesAxial);
        case 'coronal'
            axes(handles.axesCoronal);
        case 'sagittal'
            axes(handles.axesSagital);
    end
end



% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function guiWindow_WindowButtonUpFcn(hObject, eventdata, handles)
% hObject    handle to guiWindow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global left;
global right;

right=0; 
left=0;


function CambiarBrillo(min,max)
    global overlay;
    global mapa;
    
    min=ceil(min);
    if (min == 0)
        min=1;
    end
    
    max=ceil(max);
    if (max == 0 || max == 1)
        max=2;
    end
    
    
    for i=1:min
          mapa(i,1)=0;
          mapa(i,2)=0;
          mapa(i,3)=0;
    end
    
    for i=min:max
          mapa(i,1)=(i-min+1)/(max-min+1);
          mapa(i,2)=(i-min+1)/(max-min+1);
          mapa(i,3)=(i-min+1)/(max-min+1);
    end
    
    for i=max:256
          mapa(i,1)=1;
          mapa(i,2)=1;
          mapa(i,3)=1;
    end

    if (overlay == 1)
        change_alfa(0);
    else
        colormap(mapa);        
    end
    
   
        
    

% --------------------------------------------------------------------
function Tools_menu_Callback(hObject, eventdata, handles)
% hObject    handle to Tools_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function editor_menu_Callback(hObject, eventdata, handles)
% hObject    handle to editor_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function denoising_menu_Callback(hObject, eventdata, handles)
% hObject    handle to denoising_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function run_denoising_menu_Callback(hObject, eventdata, handles)
% hObject    handle to run_denoising_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

nV=save_volume;  
denoise(nV.fname);


% --------------------------------------------------------------------
function noise_estimation_menu_Callback(hObject, eventdata, handles)
% hObject    handle to noise_estimation_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global volOriginal;

disp('Estimating noise...');
h=RicianSTD(volOriginal);
disp(['Noise estimated: ', num2str(h)]);


% --------------------------------------------------------------------
function correction_menu_Callback(hObject, eventdata, handles)
% hObject    handle to correction_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

nV=save_volume;
NUCorrect(nV.fname);
        

% --------------------------------------------------------------------
function extraction_menu_Callback(hObject, eventdata, handles)
% hObject    handle to extraction_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

nV=save_volume;  
brainextract(nV.fname);

% --------------------------------------------------------------------
function classification_menu_Callback(hObject, eventdata, handles)
% hObject    handle to classification_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

nV=save_volume;  
clasify(nV.fname);

% --------------------------------------------------------------------
function segment_menu_Callback(hObject, eventdata, handles)
% hObject    handle to segment_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

nV=save_volume;  
nV.fname
segment(nV.fname);
[path, name, ext]=fileparts(nV.fname);
fileName=[path, '\crisp_', name, ext];
load_mask(fileName);

% --------------------------------------------------------------------
function over_menu_Callback(hObject, eventdata, handles)
% hObject    handle to over_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function showVolume(overlay, handles)

global cutAxial;
global cutCoronal;
global cutSagittal;
global volImg;
global volImgFusion;

    if (overlay == 1)
        
        axes(handles.axesAxial);
        image(imrotate(volImgFusion(:,:,cutAxial),90));
        set(handles.axesAxial, 'Tag', 'axial');
        axis off;

        axes(handles.axesSagital);
        sag(:,:)=volImgFusion(cutSagittal,:,:);
        image(imrotate(sag,90));
        set(handles.axesSagital, 'Tag', 'sagittal');
        axis off;

        axes(handles.axesCoronal);
        cor(:,:)=volImgFusion(:,cutCoronal,:);
        image(imrotate(cor,90));
        set(handles.axesCoronal, 'Tag', 'coronal');
        axis off;
    
    elseif (overlay == 0)
            
        axes(handles.axesAxial);
        image(imrotate(volImg(:,:,cutAxial),90));
        set(handles.axesAxial, 'Tag', 'axial');
        axis off;

        axes(handles.axesSagital);
        sag(:,:)=volImg(cutSagittal,:,:);
        image(imrotate(sag,90));
        set(handles.axesSagital, 'Tag', 'sagittal');
        axis off;

        axes(handles.axesCoronal);
        cor(:,:)=volImg(:,cutCoronal,:);
        image(imrotate(cor,90));
        set(handles.axesCoronal, 'Tag', 'coronal');
        axis off;
    end
    
    
function load_mask(fileNameOverlay)
% hObject    handle to load_overlay_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global res;
global alfa;
global volImg;
global volImgOverlay;
global volImgFusion;
global overlay;
global overImg;
global f;
global V;
global VOverlay;
global mapa;
global sizeOverImg;


if ~(fileNameOverlay == 0)
    overlayFile=strcat(fileNameOverlay);
    VOverlay = spm_vol(overlayFile);
    
    if (V.dim ~= VOverlay.dim)
        errordlg('Volume and mask dimensions must be the same', 'Dimension mismatch');
        return;
    end
    
    overImg=spm_read_vols(VOverlay);
    
    sizeOverImg=size(overImg);
        
    resOverlay(1)=abs(VOverlay.mat(1,1));
    resOverlay(2)=abs(VOverlay.mat(2,2));
    resOverlay(3)=abs(VOverlay.mat(3,3));    
   
    resMin=min(res);
       
    f=resOverlay/resMin;
    
    volTemp=volReformat(overImg, f); 
    
    volImgOverlay=resizeVol(volTemp);  
    
    volImgOverlay=volImgOverlay*256/max(volImgOverlay(:));    
            
    overlay=1;
        
    
    alfa=0.75;
    volImgFusion=0.5*volImg;
    ind=find(volImgOverlay>0);   
    volImgFusion(ind)=129 + (volImg(ind).*(volImgOverlay(ind)))/(256);
    
    if(max(overImg(:))>7) 
        disp('error: max number of tags is 7.');
        return;
    end
        
    cm=max(overImg(:));
    colors=[1,0,0;0 1 0; 0 0 1; 1 1 0; 0 1 1;1 0 1;1 1 1];   
    size(mapa);
    mcm=mapa(1:2:end,:);
    for i=1:128     
      mcm(128+i,1)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),1);
      mcm(128+i,2)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),2);
      mcm(128+i,3)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),3);
    end
    
    colormap(mcm);
    
    showVolume(overlay, handles);    

end    
    
% --------------------------------------------------------------------
function load_overlay_menu_Callback(hObject, eventdata, handles)
% hObject    handle to load_overlay_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global res;
global alfa;
global volImg;
global volImgOverlay;
global volImgFusion;
global overlay;
global overImg;
global f;
global V;
global VOverlay;
global mapa;
global sizeOverImg;


[fileNameOverlay path]=uigetfile({'*.img; *.nii'}, 'Choose your overlay file');

if ~(fileNameOverlay == 0)
    overlayFile=strcat(path, fileNameOverlay);
    VOverlay = spm_vol(overlayFile);
    
    if (V.dim ~= VOverlay.dim)
        errordlg('Volume and mask dimensions must be the same', 'Dimension mismatch');
        return;
    end
    
    overImg=spm_read_vols(VOverlay);
    
    sizeOverImg=size(overImg);
    
    resOverlay(1)=abs(VOverlay.mat(1,1));
    resOverlay(2)=abs(VOverlay.mat(2,2));
    resOverlay(3)=abs(VOverlay.mat(3,3));    
   
    resMin=min(res);
       
    f=resOverlay/resMin;
    
    volTemp=volReformat(overImg, f); 
    
    volImgOverlay=resizeVol(volTemp);  
    
    volImgOverlay=volImgOverlay*256/max(volImgOverlay(:));    
            
    overlay=1;
        
    
    alfa=0.75;
    volImgFusion=0.5*volImg;
    ind=find(volImgOverlay>0);   
    volImgFusion(ind)=129 + (volImg(ind).*(volImgOverlay(ind)))/(256);
    
    if(max(overImg(:))>7) 
        disp('error: max number of tags is 7.');
        return;
    end
        
    cm=max(overImg(:));
    colors=[1,0,0;0 1 0; 0 0 1; 1 1 0; 0 1 1;1 0 1;1 1 1];   
    size(mapa);
    mcm=mapa(1:2:end,:);
    for i=1:128     
      mcm(128+i,1)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),1);
      mcm(128+i,2)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),2);
      mcm(128+i,3)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),3);
    end
    
    colormap(mcm);
    
    showVolume(overlay, handles);    

end


function change_alfa(newMax)

global alfa;
global volImg;
global volImgOverlay;
global volImgFusion;
global overImg;
global mapa;

volImgFusion=0.5*volImg;
ind=find(volImgOverlay>0);   
volImgFusion(ind)=129 + (volImg(ind).*(volImgOverlay(ind)))/(256);
     
cm=max(overImg(:));

if (newMax > cm)
    cm = newMax;
end

colors=[1,0,0;0 1 0; 0 0 1; 1 1 0; 0 1 1;1 0 1;1 1 1];
mcm=mapa(1:2:end,:);
for i=1:128     
  mcm(128+i,1)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),1);
  mcm(128+i,2)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),2);
  mcm(128+i,3)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),3);
end
  
colormap(mcm);
    
%showVolume(overlay, handles);    


% --------------------------------------------------------------------
function unload_overlay_menu_Callback(hObject, eventdata, handles)
% hObject    handle to unload_overlay_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global overlay;
global mapa;
global enable;

overlay=0;
colormap(mapa);

enable=0;
set(handles.enable_editor_menu, 'Enable', 'on');
set(handles.disable_editor_menu, 'Enable', 'off');
set(handles.save_mask_menu, 'Enable', 'off');
set(handles.buttonPencil, 'Enable', 'off');
set(handles.popupmenu_size, 'Enable', 'off');
set(handles.popupmenu_label, 'Enable', 'off');

showVolume(overlay,handles);


% --------------------------------------------------------------------
function transparency_menu_Callback(hObject, eventdata, handles)
% hObject    handle to transparency_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function text_information_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_information (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called



function text_information_Callback(hObject, eventdata, handles)
% hObject    handle to text_information (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of text_information as text
%        str2double(get(hObject,'String')) returns contents of text_information as a double


% --------------------------------------------------------------------
function transparency_0_Callback(hObject, eventdata, handles)
% hObject    handle to transparency_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global alfa;

alfa=0;
change_alfa(0);


% --------------------------------------------------------------------
function transparency_25_Callback(hObject, eventdata, handles)
% hObject    handle to transparency_25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global alfa;
alfa=0.25;
change_alfa(0);


% --------------------------------------------------------------------
function transparency_50_Callback(hObject, eventdata, handles)
% hObject    handle to transparency_50 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global alfa;
alfa=0.5;
change_alfa(0);


% --------------------------------------------------------------------
function transparency_100_Callback(hObject, eventdata, handles)
% hObject    handle to transparency_100 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global alfa;
alfa=1;
change_alfa(0);


% --------------------------------------------------------------------
function transparency_75_Callback(hObject, eventdata, handles)
% hObject    handle to transparency_75 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global alfa;
alfa=0.75;
change_alfa(0);


% --------------------------------------------------------------------
function enable_editor_menu_Callback(hObject, eventdata, handles)
% hObject    handle to enable_editor_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global enable;
global overlay;
global overImg;
global volImg;
global res;
global alfa;
global sizeOverImg;
global volOriginal;
global volImgFusion;
global mapa;
global f;
global V;
global VOverlay;
global arg;

if (isempty(arg.img_name))
    errordlg('You have to load volume image before enable the editor tool.', 'No Volume Loaded');

else

    if (overlay == 0)
        st=size(volOriginal);

        overImg=zeros(st(1), st(2), st(3));
        
        sizeOverImg=size(overImg);

        if (enable == 0)
            enable=1;
            set(handles.enable_editor_menu, 'Enable', 'off');
            set(handles.disable_editor_menu, 'Enable', 'on');
            set(handles.save_mask_menu, 'Enable', 'on');
            set(handles.buttonPencil, 'Enable', 'on');
            set(handles.popupmenu_size, 'Enable', 'on');
            set(handles.popupmenu_label, 'Enable', 'on');
           
        end
        
        VOverlay = V;
        
        resOverlay(1)=abs(VOverlay.mat(1,1));
        resOverlay(2)=abs(VOverlay.mat(2,2));
        resOverlay(3)=abs(VOverlay.mat(3,3));
    
   
        resMin=min(res);
       
        f=resOverlay/resMin;
    
        volTemp=volReformat(overImg, f); 
    
        volImgOverlay=resizeVol(volTemp);  
    
        volImgOverlay=volImgOverlay*256/max(volImgOverlay(:));    
            
        overlay=1;
    
        alfa=0.75;
        volImgFusion=0.5*volImg;
        ind=find(volImgOverlay>0);   
        volImgFusion(ind)=129 + (volImg(ind).*(volImgOverlay(ind)))/(256);
    
        if(max(overImg(:))>7) 
            disp('error: max number of tags is 7.');
            return;
        end
        
        cm=max(overImg(:));
        
        if (cm == 0)
            cm = 1;
        end
        
        colors=[1,0,0;0 1 0; 0 0 1; 1 1 0; 0 1 1;1 0 1;1 1 1];   
        size(mapa);
        mcm=mapa(1:2:end,:);
        for i=1:128     
          mcm(128+i,1)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),1);
          mcm(128+i,2)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),2);
          mcm(128+i,3)=alfa*((i-1)/127) + (1-alfa)*colors(ceil(double(i*cm)/128),3);
        end
    
        colormap(mcm);
    
        showVolume(overlay, handles);   
    
    
        
    else
        if (enable == 0)
            enable=1;
            set(handles.enable_editor_menu, 'Enable', 'off');
            set(handles.disable_editor_menu, 'Enable', 'on');
            set(handles.save_mask_menu, 'Enable', 'on');
            set(handles.buttonPencil, 'Enable', 'on');
            set(handles.popupmenu_size, 'Enable', 'on');
            set(handles.popupmenu_label, 'Enable', 'on');
         
        end
    end
    
end



% --------------------------------------------------------------------
function disable_editor_menu_Callback(hObject, eventdata, handles)
% hObject    handle to disable_editor_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global enable;

if (enable == 1)
    enable=0;
    set(handles.enable_editor_menu, 'Enable', 'on');
    set(handles.disable_editor_menu, 'Enable', 'off');
    set(handles.save_mask_menu, 'Enable', 'off');
    set(handles.buttonPencil, 'Enable', 'off');
    set(handles.popupmenu_size, 'Enable', 'off');
    set(handles.popupmenu_label, 'Enable', 'off');
end



% --------------------------------------------------------------------
function save_denoising_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_denoising_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function configuration_menu_Callback(hObject, eventdata, handles)
% hObject    handle to configuration_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function save_options_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_options_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function save_axial_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_axial_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.save_axial_menu, 'Checked', 'on');
set(handles.save_original_menu, 'Checked', 'off');


% --------------------------------------------------------------------
function save_original_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_original_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.save_axial_menu, 'Checked', 'off');
set(handles.save_original_menu, 'Checked', 'on');


% --------------------------------------------------------------------
function exit_menu_Callback(hObject, eventdata, handles)
% hObject    handle to exit_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close all


% --------------------------------------------------------------------
function save_mask_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_mask_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global overImg;
global VOverlay;

[path,filename,ext]=fileparts(VOverlay.fname);
filename=[filename,ext];
[fileNameOverlay path]=uiputfile(filename, 'Save your overlay file');

if (fileNameOverlay ~= 0)

    VOverlay.fname=fileNameOverlay;
    spm_write_vol(VOverlay, overImg);

    disp('Mask saved!');
end


% --- Executes on button press in buttonZoom.
function buttonZoom_Callback(hObject, eventdata, handles)
% hObject    handle to buttonZoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global volImgFusion;
global cutCoronal;
global cutAxial;
global cutSagittal;
global limit_a;
global limit_s;
global limit_c;

if ( get(handles.buttonZoom, 'Value') == 1 )
    set(handles.buttonPan, 'Value', 0);
    set(handles.buttonPencil, 'Value', 0);
    set(handles.buttonPencil, 'ForegroundColor', 'Black');
    pan off;

limit_a = getappdata(handles.axesAxial,'zoom_zoomOrigAxesLimits');
limit_s = getappdata(handles.axesSagital,'zoom_zoomOrigAxesLimits');
limit_c = getappdata(handles.axesCoronal,'zoom_zoomOrigAxesLimits');

zoom on;
zoom reset;

else
    zoom off;
end

% --- Executes on button press in buttonPan.
function buttonPan_Callback(hObject, eventdata, handles)
% hObject    handle to buttonPan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ( get(handles.buttonPan, 'Value') == 1 )
    set(handles.buttonZoom, 'Value', 0);
    set(handles.buttonPencil, 'Value', 0);
    set(handles.buttonPencil, 'ForegroundColor', 'Black');
    zoom off;
    
    pan on;
else
    pan off;
end


% --- Executes on button press in buttonPencil.
function buttonPencil_Callback(hObject, eventdata, handles)
% hObject    handle to buttonPencil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global pencil;
global volImgFusion;
global cutCoronal;
global cutAxial;
global cutSagittal;
global limit_a;
global limit_s;
global limit_c;


if ( get(handles.buttonPencil, 'Value') == 1 )
    set(handles.buttonPencil, 'ForegroundColor', 'Red');
    
    set(handles.buttonZoom, 'Value', 0);
    zoom off;
    
    set(handles.buttonPan, 'Value', 0);
    pan off;
    
    pencil = 1;
    
    zoom reset;    
    
else
    set(handles.buttonPencil, 'ForegroundColor', 'Black');
    pencil = 0;
    
    setappdata(handles.axesAxial,'zoom_zoomOrigAxesLimits',limit_a);
    setappdata(handles.axesSagital,'zoom_zoomOrigAxesLimits',limit_s);
    setappdata(handles.axesCoronal,'zoom_zoomOrigAxesLimits',limit_c);
        
    axes(handles.axesAxial);
    image(imrotate(volImgFusion(:,:,cutAxial),90));
    set(handles.axesAxial, 'Tag', 'axial');
    axis off;

    axes(handles.axesSagital);
    sag(:,:)=volImgFusion(cutSagittal,:,:);
    image(imrotate(sag,90));
    set(handles.axesSagital, 'Tag', 'sagittal');
    axis off;
    
    axes(handles.axesCoronal);
    cor(:,:)=volImgFusion(:,cutCoronal,:);
    image(imrotate(cor,90));
    set(handles.axesCoronal, 'Tag', 'coronal');
    axis off;  
    
end


% --- Executes on selection change in popupmenu_size.
function popupmenu_size_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu_size contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_size


% --- Executes during object creation, after setting all properties.
function popupmenu_size_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_label.
function popupmenu_label_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu_label contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_label


% --- Executes during object creation, after setting all properties.
function popupmenu_label_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% --------------------------------------------------------------------
function documentation_menu_Callback(hObject, eventdata, handles)
% hObject    handle to documentation_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
dir=[pwd, '\doc\index.html'];
open(dir);


% --------------------------------------------------------------------
function about_menu_Callback(hObject, eventdata, handles)
% hObject    handle to about_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
open about.fig;

