function varargout = loadFile(varargin)
% LOADFILE M-file for loadFile.fig
%      LOADFILE, by itself, creates a new LOADFILE or raises the existing
%      singleton*.
%
%      H = LOADFILE returns the handle to a new LOADFILE or the handle to
%      the existing singleton*.
%
%      LOADFILE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LOADFILE.M with the given input arguments.
%
%      LOADFILE('Property','Value',...) creates a new LOADFILE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before loadFile_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to loadFile_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help loadFile

% Last Modified by GUIDE v2.5 25-Nov-2009 14:27:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @loadFile_OpeningFcn, ...
                   'gui_OutputFcn',  @loadFile_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before loadFile is made visible.
function loadFile_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to loadFile (see VARARGIN)

% Choose default command line output for loadFile
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes loadFile wait for user response (see UIRESUME)
% uiwait(handles.figure1);



% --- Outputs from this function are returned to the command line.
function varargout = loadFile_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object creation, after setting all properties.
function editFilePath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editFilePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnBrowse.
function btnBrowse_Callback(hObject, eventdata, handles)
% hObject    handle to btnBrowse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global arg;

[fileName path]=uigetfile({'*.img; *.nii'}, 'Choose your acquisition file');

if ~(fileName == 0)
    arg.img_name=strcat(path, fileName);        
    
    V=spm_vol(arg.img_name);
    vol=spm_read_vols(V);
    
    % Show cut 100 preview
    s=size(vol);
    axes(handles.axesPreview);
    cor(:,:)=vol(:,:,round(s(3)/2));
    colormap(gray);
    imagesc(imrotate(cor,90));
    axis off;
    
    
end

% --- Executes during object creation, after setting all properties.
function axesPreview_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axesPreview (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axesPreview

axis off;
return

% --- Executes on button press in btnOk.
function btnOk_Callback(hObject, eventdata, handles)
% hObject    handle to btnOk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close 'Load acquisition file';
gui

return


% --- Executes during object creation, after setting all properties.
function btnGroupCuts_CreateFcn(hObject, eventdata, handles)
% hObject    handle to btnGroupCuts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
global arg
    arg.axial=1;
    arg.coronal=0;
    arg.sagittal=0;


% --- Executes when selected object is changed in btnGroupCuts.
function btnGroupCuts_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in btnGroupCuts 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
global arg

if (hObject == handles.radiobuttonAxial)
    arg.axial=1;
    arg.coronal=0;
    arg.sagittal=0;
elseif (hObject == handles.radiobuttonCoronal)
    arg.axial=0;
    arg.coronal=1;
    arg.sagittal=0;
else
    arg.axial=0;
    arg.coronal=0;
    arg.sagittal=1;
end


