#include "math.h"
#include "mex.h"
#include <stdlib.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{

//Declarations
mxArray *xData;
double *ima, *fima,*medias;
mxArray *pv;
double mindis,dis;
int i,j,k,c,ndim,n,p,off;
const int  *dims;
int * ndims;

//Copy input pointer x
xData = prhs[0];

//Get matrix x
ima = mxGetPr(xData);

ndim = mxGetNumberOfDimensions(prhs[0]);
dims= mxGetDimensions(prhs[0]);

//Copy input parameters
pv = prhs[1];
//Get the Integer
c = (int)(mxGetScalar(pv));

//Copy input parameters
pv = prhs[2];

//Get matrix x
medias = mxGetPr(pv);

//Allocate memory and assign output pointer

//printf("ancho=%d\r",dims[0]);
//printf("alto=%d\r",dims[1]);
//printf("profundo=%d\r",dims[2]);

ndims=(int*)malloc(4*sizeof(int));

ndim=ndim+1;
ndims[0]=dims[0];
ndims[1]=dims[1];
ndims[2]=dims[2];
ndims[3]=c+1;

plhs[0] = mxCreateNumericArray(ndim,ndims,mxDOUBLE_CLASS, mxREAL);

//Get a pointer to the data space in our newly allocated memory
fima = mxGetPr(plhs[0]);

off=dims[0]*dims[1]*dims[2];

for(k=0;k<dims[2];k++)
{
for(i=0;i<dims[1];i++)
{
  for(j=0;j<dims[0];j++)
  {
      p=k*(dims[0]*dims[1])+(i*dims[0])+j;
      
      if(ima[p]>0)
      { 
        // CSF  
        if(ima[p]<medias[0])
        {
            fima[c*off + p]=1;
            fima[p]=1;
            continue;
        }
        // WM
        if(ima[p]>medias[c-1])
        {
            if(ima[p]>(medias[c-1]+(medias[c-1]+medias[c-2])/2)) continue; // vessels
            fima[c*off + p]=3;
            fima[(c-1)*off + p]=1;
            continue;
        }  
        // CSF/GM and GM/WM
        for(n=0;n<c-1;n++)
        {
           if(ima[p]>=medias[n] && ima[p]<=medias[n+1])               
           {
              fima[(n+1)*off + p]=(ima[p]-medias[n])/(medias[n+1]-medias[n]);
              fima[n*off + p]=1-fima[(n+1)*off + p];              
              if(fima[n*off + p]>fima[(n+1)*off + p]) fima[c*off + p]=n+1;                               
              else fima[c*off + p]=n+2;                               
           }                           
        }        
      }
      else fima[p]=0;
  }
}
}


return;

}

