#include "math.h"
#include "mex.h"
#include <stdlib.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{

//Declarations
mxArray *xData,*pv;
double *ima, *fima,*medias,*prob;
double mindis,dis;
int i,j,k,c,ndim,n,p,off,c1,c2;
const int  *dims;
int * ndims;

c=3; // numbero of pure tissues

//Copy input pointer x
xData = prhs[0];
ima = mxGetPr(xData);

ndim = mxGetNumberOfDimensions(prhs[0]);
dims= mxGetDimensions(prhs[0]);

//Copy input pointer x
xData = prhs[1];
prob = mxGetPr(xData);

//Copy input parameters
pv = prhs[2];
medias = (double*) mxGetPr(pv);

// alocate memory

ndims=(int*)malloc(4*sizeof(int));

ndim=ndim+1;
ndims[0]=dims[0];
ndims[1]=dims[1];
ndims[2]=dims[2];
ndims[3]=c+1;


//Get a pointer to the data space in our newly allocated memory
plhs[0] = mxCreateNumericArray(ndim,ndims,mxDOUBLE_CLASS, mxREAL);
fima = mxGetPr(plhs[0]);

off=dims[0]*dims[1]*dims[2];

for(k=0;k<dims[2];k++)
{
for(i=0;i<dims[1];i++)
{
  for(j=0;j<dims[0];j++)
  {
	  p=k*(dims[0]*dims[1])+(i*dims[0])+j;
       
      if(ima[p]>0)
      { 
        c1=0;
        c2=0;
		
        if(prob[p]>=prob[2*off+p] && prob[p]>=prob[off+p])//csf
        {
            c1=0;
            if(prob[2*off+p]>prob[off+p]) // wm
            {
                c2=2;
            }
            else // gm
            {
                if(prob[2*off+p]<prob[off+p]) c2=1;
                else
                {
                    if(abs(ima[p]-medias[1])<abs(ima[p]-medias[2])) c2=1;
                    else c2=2;
                }                
            }            
        }
        if(prob[off+p]>=prob[p] && prob[off+p]>=prob[2*off+p])//gm
        {
            c1=1;
            if(prob[2*off+p]>prob[p]) // wm
            {
                c2=2;
            }
            else // csf
            {
                if(prob[2*off+p]<prob[p]){c1=0; c2=1;}
                else
                {
                    if(abs(ima[p]-medias[0])<abs(ima[p]-medias[2])) {c1=0;c2=1;}
                    else c2=2;
                }                
            }             
           
        }
        if(prob[2*off+p]>=prob[p] && prob[2*off+p]>=prob[off+p])//wm
        {
            c2=2;
            if(prob[off+p]>prob[p]) // gm
            {
                c1=1;
            }
            else // csf
            {
                if(prob[off+p]<prob[p]){c1=0;}
                else
                {
                    if(abs(ima[p]-medias[0])<abs(ima[p]-medias[1])) {c1=0;}
                    else c1=1;
                }                
            }
           
        }   
           
	    if(ima[p]<medias[0] && c1==0) 
        {
				// soft
				fima[p]=1;
				fima[c2*off+p]=0;
				
				//hard
                fima[3*off+p]=1;
                continue;
        }
	    if(ima[p]>medias[2] && c2==2) 
		{
				// soft
				fima[c1*off+p]=0;
				fima[2*off+p]=1;
				
				//hard
                fima[3*off+p]=3;
                continue;
		}
        
		//soft
        fima[c2*off+p]=(ima[p]-medias[c1])/(medias[c2]-medias[c1]);                    
    	fima[c1*off+p]=1-fima[c2*off+p];

		// hard
		if(fima[c1*off+p]>fima[c2*off+p]) fima[3*off+p]=c1+1;
		else fima[3*off+p]=c2+1;             
		 
      }      
  }
}
}


return;

}

