function pvcs=refine(ima, mascara, c)

% refine intensity based segmentation using self spatial priors
% for WM, GM, CSF, CSF/GM, CSF/WM and GM/WM 

csf=mascara(:,:,:,1);
gm=mascara(:,:,:,2);
wm=mascara(:,:,:,3);
clear mascara;

% calculate CSF/WM interface 
kernel=makekernel(1);
pwm=convn(wm,kernel,'same');
pcsf=convn(csf,kernel,'same');
d=abs(pwm.*pcsf);
%d=d.^2;
d=d/max(d(:));

% select only the ventricles (glial matter)
%clf
%colormap(gray);

s=size(wm);
for i=1:s(3)
%subplot(2,2,1),imagesc(wm(:,:,i)>0.2)
cwm(:,:,i)=imfill(wm(:,:,i)>0.2,'holes');
%a=cwm(:,:,i);
%max(a(:))
cwm(:,:,i)=imerode(100*cwm(:,:,i),ones(3))>0.2;
%b=cwm(:,:,i);
%max(b(:))
%subplot(2,2,2),imagesc(cwm(:,:,i))
%pause

end
d=d.*cwm;

% new map probability of gm and for csf and wm
d=double(d>0.25);
ind=find(d);
gm(ind)=0;
wm(ind)=0.5;
csf(ind)=0.5;


% clear 
clear pwm;
clear pcsf;
clear d;

% recalculate pvcs
prob(:,:,:,1)=csf;
prob(:,:,:,2)=gm;
prob(:,:,:,3)=wm;
pvcs=cCreateMaskSoft2(ima,prob,c);





