#include "math.h"
#include "mex.h"
#include <stdlib.h>
#include "matrix.h"
// undef needed for LCC compiler
#undef EXTERN_C
#include <windows.h>
#include <process.h>  

typedef struct{
    int rows;
    int cols;
    int slices;
    double * in_image;
    double * out_image;
    double * medias_image;
    double * var_image;
    double * pesos;    
    double * wmax;    
    int ini;
    int fin;
    int radioB;
    int radioS;
    double sigma;    
}myargument;

int rician;

double distancia(double* ima,int x,int y,int z,int nx,int ny,int nz,int f,int sx,int sy,int sz)
{
double d,acu,distancetotal;
int i,j,k,ni1,nj1,ni2,nj2,nk1,nk2,kk,inc;

acu=0;
distancetotal=0;
for(k=-f;k<=f;k++)
{
 for(i=-f;i<=f;i++)
 {
  for(j=-f;j<=f;j++)
  {
    ni1=x+i;
    nj1=y+j;
    nk1=z+k;
    ni2=nx+i;
    nj2=ny+j;
    nk2=nz+k;
    
    if(ni1<0) ni1=-ni1;
    if(nj1<0) nj1=-nj1;
    if(ni2<0) ni2=-ni2;
    if(nj2<0) nj2=-nj2;
    if(nk1<0) nk1=-nk1;
    if(nk2<0) nk2=-nk2;

	if(ni1>=sx) ni1=2*sx-ni1-1;
    if(nj1>=sy) nj1=2*sy-nj1-1;
    if(nk1>=sz) nk1=2*sz-nk1-1;
    if(ni2>=sx) ni2=2*sx-ni2-1;
    if(nj2>=sy) nj2=2*sy-nj2-1;
    if(nk2>=sz) nk2=2*sz-nk2-1;
     
	inc=1;
    if(i==0 && j==0 && k==0) inc=2;

    distancetotal = distancetotal + ((ima[nk1*(sx*sy)+(nj1*sx)+ni1]-ima[nk2*(sx*sy)+(nj2*sx)+ni2])*(ima[nk1*(sx*sy)+(nj1*sx)+ni1]-ima[nk2*(sx*sy)+(nj2*sx)+ni2]))*inc;
    acu=acu + inc;
  }
 }
}
d=distancetotal/acu;
return d;
}

unsigned __stdcall ThreadFunc( void* pArguments )
{
    double *wmax,*ima,*fima,*medias,*varianzas,*pesos,val,sigma,w,nv,d,th,hh,t1,t2;
    int ii,jj,kk,ni,nj,nk,i,j,k,ini,fin,rows,cols,slices,v,p,p1,f;
    extern int rician;
    
    myargument arg;
    arg=*(myargument *) pArguments;

    rows=arg.rows;    
    cols=arg.cols;
    slices=arg.slices;
    ini=arg.ini;    
    fin=arg.fin;
    ima=arg.in_image;
    fima=arg.out_image;
    medias=arg.medias_image;
    varianzas=arg.var_image;
    pesos=arg.pesos;
    wmax=arg.wmax;
    v=arg.radioB;
    f=arg.radioS;
    sigma=arg.sigma;
        
    hh=2*sigma*sigma;
    
    /* filter*/
    for(k=ini;k<fin;k++)
    {
	for(j=0;j<rows;j++)
	{
		for(i=0;i<cols;i++)
		{		
            p=k*cols*rows+(j*cols)+i;                                 
			for(kk=0;kk<=v;kk++)
            {
			for(jj=-v;jj<=v;jj++)
			{
            for(ii=-v;ii<=v;ii++)
            {
				ni=i+ii;
				nj=j+jj;
				nk=k+kk;
                                
                if(kk==0 && jj<0) continue;             
                if(kk==0 && jj==0 && ii<=0) continue;  
				
				if(ni>=0 && nj>=0 && nk>=0 && ni<cols && nj<rows && nk<slices)
				{
                     p1=nk*cols*rows+(nj*cols)+ni;                            
                     t1 = (medias[p]/medias[p1]);  
                     t2 = (varianzas[p]/varianzas[p1]);  
              
                     if(t1<0.95 || t1>1.05 || t2<0.5 || t2>2) continue;
              
                     d=distancia(ima,i,j,k,ni,nj,nk,f,cols,rows,slices);                          
                                   
                     d=d/hh;                     
                     w = exp(-d);
                     if(w>wmax[p]) wmax[p]=w;
                     if(w>wmax[p1]) wmax[p1]=w;
                         
                     if(rician>0)
                     {
                       fima[p] += w*ima[p1]*ima[p1];
                       pesos[p]+= w;
                                         
                       fima[p1] += w*ima[p]*ima[p];
                       pesos[p1]+= w;                         
                     }
                     else
                     {
                       fima[p] += w*ima[p1];
                       pesos[p]+= w;
                                         
                       fima[p1] += w*ima[p];
                       pesos[p1]+= w;                         
                     }
                }		 
            }
			}							
            }
            /*if(wmax==0) wmax=1;
            if(rician>0) fima[p] += wmax*ima[p]*ima[p];
            else fima[p] += wmax*ima[p];
            pesos[p]+= wmax;                    */
                                        
		}
	}
    }

    _endthreadex( 0 );
    return 0;
} 


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{

/*Declarations*/
mxArray *xData,*xtmp,*xpesos,*Mxmedias,*Mxvarianzas,*Mxmax;
double *ima, *fima,*pesos,*medias,*varianzas,*wmax;
double average,totalweight,off,media,bw;
mxArray *pv;
double vr,R,dg,h,w,d,var,t1,t1i,t2,hh,min,SNR,SNR2,level2,level;
int ini,fin,i,j,k,ii,jj,kk,ni,nj,nk,v,f,ndim,indice,Ndims,init,r,un,p,p1,Nthreads;
const int  *dims ;
bool salir;

myargument *ThreadArgs;  
HANDLE *ThreadList; // Handles to the worker threads     

/*Copy input pointer x*/
xData = prhs[0];

/*Get matrix x*/
ima = mxGetPr(xData);

ndim = mxGetNumberOfDimensions(prhs[0]);
dims= mxGetDimensions(prhs[0]);

pv = prhs[1];
v = (int)(mxGetScalar(pv));
pv = prhs[2];
f = (int)(mxGetScalar(pv));
pv = prhs[3];
h = (double)(mxGetScalar(pv));
pv = prhs[4];
rician = (int)(mxGetScalar(pv));


/*Allocate memory and assign output pointer*/

plhs[0] = mxCreateNumericArray(ndim,dims,mxDOUBLE_CLASS, mxREAL);
fima = mxGetPr(plhs[0]);
Mxmedias = mxCreateNumericArray(ndim,dims,mxDOUBLE_CLASS, mxREAL); 
Mxvarianzas = mxCreateNumericArray(ndim,dims,mxDOUBLE_CLASS, mxREAL); 
medias = mxGetPr(Mxmedias);
varianzas = mxGetPr(Mxvarianzas);
xpesos = mxCreateNumericArray(ndim,dims,mxDOUBLE_CLASS, mxREAL); 
pesos = mxGetPr(xpesos);
Mxmax = mxCreateNumericArray(ndim,dims,mxDOUBLE_CLASS, mxREAL); 
wmax = mxGetPr(Mxmax);

for(k=0;k<dims[2];k++)
{
for(j=0;j<dims[1];j++)
{
  for(i=0;i<dims[0];i++)
  {
        media=0;
        indice=0;
      	for(ii=-1;ii<=1;ii++)
        {
		  for(jj=-1;jj<=1;jj++)
          {
            for(kk=-1;kk<=1;kk++)
            {
              ni=i+ii;
		      nj=j+jj;		   		  
              nk=k+kk;
               
              if(ni<0) ni=-ni;
              if(nj<0) nj=-nj;
              if(nk<0) nk=-nk;
	          if(ni>=dims[0]) ni=2*dims[0]-ni-1;
              if(nj>=dims[1]) nj=2*dims[1]-nj-1;
              if(nk>=dims[2]) nk=2*dims[2]-nk-1;
                           
              media = media + ima[nk*(dims[0]*dims[1])+(nj*dims[0])+ni];
              indice=indice+1;                             
            }
         }
        }
        media=media/indice;
        medias[k*(dims[0]*dims[1])+(j*dims[0])+i]=media;
  }
}
}

for(k=0;k<dims[2];k++)
{
for(j=0;j<dims[1];j++)
{
  for(i=0;i<dims[0];i++)
  {
        media=0;
        indice=0;
      	for(ii=-1;ii<=1;ii++)
        {
		  for(jj=-1;jj<=1;jj++)
          {
            for(kk=-1;kk<=1;kk++)
            {
              ni=i+ii;
		      nj=j+jj;		   		  
              nk=k+kk;
               
              if(ni<0) ni=-ni;
              if(nj<0) nj=-nj;
              if(nk<0) nk=-nk;
	          if(ni>=dims[0]) ni=2*dims[0]-ni-1;
              if(nj>=dims[1]) nj=2*dims[1]-nj-1;
              if(nk>=dims[2]) nk=2*dims[2]-nk-1;
                           
              media = media + (ima[nk*(dims[0]*dims[1])+(nj*dims[0])+ni]-medias[k*(dims[0]*dims[1])+(j*dims[0])+i])*(ima[nk*(dims[0]*dims[1])+(nj*dims[0])+ni]-medias[k*(dims[0]*dims[1])+(j*dims[0])+i]);
              indice=indice+1;                             
            }
         }
        }
        media=media/(indice-1);
        varianzas[k*(dims[0]*dims[1])+(j*dims[0])+i]=media;
  }
}
}

for(k=0;k<dims[2]*dims[1]*dims[0];k++)
{
    fima[k]=0;
    pesos[k]=0;
    wmax[k]=0;
}

Nthreads = 8;//dims[2];//floor((double)dims[2]/(double)B);
if(Nthreads<1) Nthreads=1;
if(Nthreads>dims[2]) Nthreads=dims[2];

// Reserve room for handles of threads in ThreadList
ThreadList = (HANDLE*)malloc(Nthreads* sizeof( HANDLE ));
ThreadArgs = (myargument*) malloc( Nthreads*sizeof(myargument));
    

for (i=0; i<Nthreads; i++)
{       
	// Make Thread Structure
    ini=(i*dims[2])/Nthreads;
    fin=((i+1)*dims[2])/Nthreads;
    
    //printf("ini=%d fin=%d\r",ini,fin);
       
   	ThreadArgs[i].cols=dims[0];
    ThreadArgs[i].rows=dims[1];
   	ThreadArgs[i].slices=dims[2];
    ThreadArgs[i].in_image=ima;
	ThreadArgs[i].out_image=fima;
  	ThreadArgs[i].medias_image=medias;
    ThreadArgs[i].var_image=varianzas;
    ThreadArgs[i].pesos=pesos;
    ThreadArgs[i].wmax=wmax;
    ThreadArgs[i].ini=ini;
    ThreadArgs[i].fin=fin;
    ThreadArgs[i].radioB=v;
    ThreadArgs[i].radioS=f;
    ThreadArgs[i].sigma=h;    
	
    ThreadList[i] = (HANDLE)_beginthreadex( NULL, 0, &ThreadFunc, &ThreadArgs[i] , 0, NULL );
}
    
for (i=0; i<Nthreads; i++) { WaitForSingleObject(ThreadList[i], INFINITE); }
for (i=0; i<Nthreads; i++) { CloseHandle( ThreadList[i] ); }
    
free(ThreadArgs); 
free(ThreadList);

for(k=0;k<dims[2]*dims[1]*dims[0];k++)
{
    if(wmax[k]==0) wmax[k]=1;
    if(rician) fima[k]+=ima[k]*ima[k]*wmax[k];
    else fima[k]+=ima[k]*wmax[k];
    pesos[k]+=wmax[k];
}

for(k=0;k<dims[2]*dims[1]*dims[0];k++) 
{
    if(rician>0)
    {
        vr=fima[k]/pesos[k]-2*h*h;
        vr=vr<0?0:vr;
        fima[k]=sqrt(vr);
    }
    else fima[k]/=pesos[k];
}

return;
}

