function clasify(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Clasify a Brain stripted MRI T1w volume in CSF,GM and WM tissues
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
warning off;

%addpath e:\spm8
%addpath .\Clasificacion

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if(nargin==0)
  filename=spm_select;
end

disp('Loading data ...');

[path,name,ext]=fileparts(filename);
%cd ..
%resultspath=[pwd,'\results\',name,'\'];
%cd prototipo
fname=[name,ext];
%mkdir(resultspath)

V=spm_vol(filename);
ima=spm_read_vols(V);
ima=double(ima);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% clasification de tejidos
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

disp('Segmenting ...');

c=TMS(ima,3);
mascara=cCreateMaskSoft(ima,3,c);

% V.dt(1)=16;
% V.pinfo(1)=1;
% V.fname=[resultspath,'csf',fname];
% spm_write_vol(V,double(squeeze(mascara(:,:,:,1))));
% V.fname=[resultspath,'gm',fname];
% spm_write_vol(V,double(squeeze(mascara(:,:,:,2))));
% V.fname=[resultspath,'wm',fname];
% spm_write_vol(V,double(squeeze(mascara(:,:,:,3))));
% V.dt(1)=8;
% V.fname=[resultspath,'crisp',fname];
% spm_write_vol(V,double(squeeze(mascara(:,:,:,4))));

mascara=refine(ima,mascara,c);

V.dt(1)=16;
V.pinfo(1)=1;
V.fname=[path,'\new_csf',fname];
spm_write_vol(V,double(squeeze(mascara(:,:,:,1))));
V.fname=[path,'\new_gm',fname];
spm_write_vol(V,double(squeeze(mascara(:,:,:,2))));
V.fname=[path,'\new_wm',fname];
spm_write_vol(V,double(squeeze(mascara(:,:,:,3))));
V.dt(1)=8;
V.fname=[path,'\new_crisp',fname];
spm_write_vol(V,double(squeeze(mascara(:,:,:,4))));
 
disp('Done!');

% tissue volumes

csf=mascara(:,:,:,1);
csfvol=sum(csf(:))/1000 
gm=mascara(:,:,:,2);
gmvol=sum(gm(:))/1000 
wm=mascara(:,:,:,3);
wmvol=sum(wm(:))/1000 

tiv=(gmvol+wmvol+csfvol) % Total intracraneal volume
ncsf=csfvol/tiv % normalized csf volume
ngm=gmvol/tiv % normalized gray matter volume
nwm=wmvol/tiv % normalized white matter volume
nbv=(gmvol+wmvol)/tiv % normalized brain volume 

fn=[path,'\volumes.txt'];
if (~exist(fn, 'file'))
    fid = fopen(fn,'a+');
    fprintf(fid,'Filename\t   CsfVol(mm3)\t     GmVol(mm3)\t     WmVol(mm3)\t     TIV(mm3)\t     Ncsf(%%)\t     Ngm(%%)\t     Nwm(%%)\t     Nbv(%%)\r\n');
    fclose(fid);
end
fid = fopen(fn,'a+');
fprintf(fid,'%s\t %1.2f\t %1.2f\t %1.2f\t %1.2f\t %1.2f\t %1.2f\t %1.2f\t %1.2f\r\n', fname, csfvol, gmvol, wmvol, tiv, ncsf, ngm, nwm, nbv);
fclose(fid);
