function denoise(filename)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Denosie MRI T1w volume 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
warning off;

%addpath 'modules\Denoising'

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if(nargin==0)
  filename=spm_select;
end

disp('Loading data ...');

[path,name,ext]=fileparts(filename);
%resultspath=[pwd,'\results\',name,'\'];
fname=[name,ext];
%mkdir(resultspath)

V=spm_vol(filename);
ima=spm_read_vols(V);
ima=double(ima);

%************************************************
% denoising
%************************************************

disp('Denoising ...');

% Estimate noise
h=RicianSTD(ima);
disp(['Estimated Noise: ', num2str(h)]);

% perform denoising
%fima=cM_VNLM3D(ima,3,1,h,1);
fima=MBONLM3D(ima,3,1,h,1);

% save residuals
V.fname=[path,'\res',fname];
spm_write_vol(V,ima-fima);

% save data
V.fname=[path,'\f',fname];
spm_write_vol(V,fima);

clear ima;
clear fima;

disp('Done!');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
