function run_batch (files, opts)

% opts
% pause

for i=1:opts.nfiles
            
    if (opts.nfiles == 1) 
        axFile=files;
    else
        axFile=files(i,:);
    end           
    
    if (opts.reorient == 1)            
       axFile=reorientation(opts.orientation,axFile,opts.save);
    end
            
    [path,name,ext]=fileparts(axFile);
    fname=[name, ext];
            
            % Some messages
            disp('#####################################');
            disp(['# Processing file ', fname]);
            disp(['# File number ', num2str(i), ' of ', num2str(opts.nfiles), '.']);            
            disp('#####################################');
            
            
            
            % Check if user has checked tissue clasificattion
            if (opts.segment == 1)
                disp(' ');
                disp('Applying Segmentation on file ...');
                segment(axFile);
                
                if (opts.remove == 1)
                    [path,name,ext]=fileparts(axFile);
                    fileName=[name,ext];
                    
                    % Delete intermedied files...
                    delete(axFile);
                    delete([path,'\res_', fileName]);
                    delete([path,'\f_', fileName]);
                    delete([path,'\e_', fileName]);
                    delete([path,'\mask_', fileName]);
                end
                
                return;
            end
            
            % Check if user has checked denoising
            if (opts.denoising == 1)
                disp(' ');
                disp('Applying Denoising on file ...');
                denoise(axFile);
                
                % Update variable path
                [path,name,ext]=fileparts(axFile);
                fname=['f', name, ext];
                axFile=[path, '\', fname];
            end
            
            
            % Check if user has checked inhomogenity correction
            if (opts.correction == 1)
                disp(' ');
                disp('Applying Inhomogenity Correction on file ...');
                NUCorrect(axFile);
                
                % Update variable path
                [path,name,ext]=fileparts(axFile);
                fname=['m_', name, ext];
                axFile=[path, '\', fname];
            end
            
            
            
            % Check if user has checked brain extraction
            if (opts.extraction == 1)
                disp(' ');
                disp('Applying Brain Extraction on file ...');
                brainextract(axFile);
                
                % Update variable path
                [path,name,ext]=fileparts(axFile);
                fname=['e_', name, ext];
                axFile=[path, '\', fname];
            end
            
            
            % Check if user has checked tissue clasificattion
            if (opts.clasify == 1)
                disp(' ');
                disp('Applying Brain Extraction on file ...');
                clasify(axFile);    
            end
            
end % Loop end

    disp(['All data stored under ', opts.save, ' directory.']);
    
    warning('ON', 'MATLAB:MKDIR:DirectoryExists'); % Enable again