% This function is called before run any module to store volume as axial
% orientation or original orientation. That orientation must be chosen in
% Options menu.
function [nV]=save_volume
        
global resultspath;
global fname;
global vol;
global volOriginal;
global arg;
global V;
global res;
global origin;

handles = guihandles(gcf);

nV=V;

% Check if we have to save as axial or as original adquisition type.
if (arg.axial==0 && strcmp(get(handles.save_axial_menu, 'Checked'),'on'))
        
    % Assume that some image are loaded, because menu is enabled, so don't
    % check again.
    
        [path,name,ext]=fileparts(arg.img_name);
        resultspath=[pwd,'\results\',name,'\'];

        fname=[name,ext];
        mkdir(resultspath);

        nV.dim=size(vol);
        nV.fname=[resultspath,'ax_',fname];
        
        nV.mat(1,1)=-res(1);%-res(1);
        nV.mat(2,2)=res(2);
        nV.mat(3,3)=res(3);
        
        %nV.mat(1:3,4)=(size(vol).*res)/2;
        %nV.mat(2:3,4)=-V.mat(2:3,4);                
        nV.mat(1,4)=abs(origin(1));
        nV.mat(2,4)=-abs(origin(2));
        nV.mat(3,4)=-abs(origin(3));
        
        spm_write_vol(nV,vol);
                        
else % If save as original is checked
    
        [path,name,ext]=fileparts(arg.img_name);
        resultspath=[pwd,'\results\',name,'\'];

        fname=[name,ext];
        mkdir(resultspath);

        nV.fname=[resultspath,fname];
        spm_write_vol(nV,volOriginal);        
end